<?php
/*
Plugin Name: Sidebar editor
Plugin URI: http://flapjack.chips.jp/blog/pp/Sidebar-editor/
Description: Re-order sidebar contents plus add user original contents.
Version: 1.6
License: GPL
Author: Muneo Takemoto
Author URI: http://flapjack.chips.jp/blog/pp
*/
//@setcookie('dbx-main');

if(!function_exists( "se_unescape" )){
	function se_unescape($val){
			$val = stripslashes($val);
			$val = value_decode($val);
			$val = str_replace("&lt;","<",$val);
			$val = str_replace("&gt;",">",$val);

			return $val;
	}
}

if(!function_exists( "se_get_sidebar" )){
	function se_get_sidebar($sidebar_no=1,$getsearchform=FALSE){

if(file_exists(TEMPLATEPATH . "/se_settings.php")){
require(TEMPLATEPATH . "/se_settings.php");
}

if($sidebar_no==2){
	$se_content = get_option('se_sidebar_contents2');
	$se_options = get_option('se_sidebar_options2');
}	else{
	$se_content = get_option('se_sidebar_contents');
	$se_options = get_option('se_sidebar_options');
}


if(!is_array($se_content)){$se_content = unserialize($se_content);}
if(!is_array($se_options)){$se_options = unserialize($se_options);}


			$before = se_unescape($se_options['before']);
			$after = se_unescape($se_options['after']);
			if(!isset($con_before)){$con_before = se_unescape($se_options['con_before']);}
			if(!isset($con_after)){$con_after = se_unescape($se_options['con_after']);}
			$se_place = se_unescape($se_options['place']);

//###Printing process###//

if(empty($se_custom_div)){
echo "<div id='sidebar'";

if($se_place_changable){
	if($se_place=="left" or $se_place=="right"){echo " style='float:" . $se_place . ";'";}
	}

echo ">";
}
else{echo $se_custom_div[ 'before' ];}
echo $con_before;

		foreach($se_content as $val){
		if($val[ 'visibility' ] == "+"){
			extract($val);
			$h_before = se_unescape($h_before);
			$h_after = se_unescape($h_after);
			$opt_before = se_unescape($opt_before);
			$opt_after = se_unescape($opt_after);
			$l_before = se_unescape($l_before);
			$l_after = se_unescape($l_after);
			$content = se_unescape($content);

if($se_theme_profile){
if(!empty($se_theme_profile[$name][ 'before' ])){$before = $se_theme_profile[$name][ 'before' ];}
if(!empty($se_theme_profile[$name][ 'after' ])){$after = $se_theme_profile[$name][ 'after' ];}
if(!empty($se_theme_profile[$name][ 'h_before' ])){$h_before = $se_theme_profile[$name][ 'h_before' ];}
if(!empty($se_theme_profile[$name][ 'h_after' ])){$h_after = $se_theme_profile[$name][ 'h_after' ];}
if(!empty($se_theme_profile[$name][ 'l_before' ])){$l_before = $se_theme_profile[$name][ 'l_before' ];}
if(!empty($se_theme_profile[$name][ 'l_after' ])){$l_after = $se_theme_profile[$name][ 'l_after' ];}
if(!empty($se_theme_profile[$name][ 'opt_before' ])){$opt_before = $se_theme_profile[$name][ 'opt_before' ];}
if(!empty($se_theme_profile[$name][ 'opt_after' ])){$opt_after = $se_theme_profile[$name][ 'opt_after' ];}
if(!empty($se_theme_profile[$name][ 'headline' ])){$headline = $se_theme_profile[$name][ 'headline' ];}
}

			if($name == "original"){
				if($br==1){$content = nl2br($content);}
			echo $before . "\n" . $h_before . $headline . $h_after . "\n" . $l_before . $content . $l_after . $after . "\n";
			}

			else if($name == "calendar"){
			if(!empty($se_theme_profile[$name][ 'function' ])){eval($se_theme_profile[$name][ 'function' ]);}
			else {echo get_calendar();}
			}

			else if($name == "links"){
			if(!empty($se_theme_profile[$name][ 'function' ])){eval($se_theme_profile[$name][ 'function' ]);}
			else{get_links_list();}
			}

			else if($name == "pages"){
			$t_li = "title_li=" . $h_before . $headline . $h_after;
			if(!empty($se_theme_profile[$name][ 'function' ])){eval($se_theme_profile[$name][ 'function' ]);}
			else{wp_list_pages($t_li);}
			}

			else if($name == "archives"){
			echo $before . "\n" . $h_before . $headline . $h_after . $l_before . "\n";
			$arctype = "type=" . $opt_type . "&limit=" . $opt_limit . "&before=" . $opt_before . "&after=" . $opt_after;
			if(!empty($se_theme_profile[$name][ 'function' ])){eval($se_theme_profile[$name][ 'function' ]);}
			else{wp_get_archives($arctype);}
			echo $l_after . $after . "\n";
			}

			else if($name == "categories"){
			echo $before . "\n" . $h_before . $headline . $h_after . $l_before . "\n";
			$wlc = "sort_column=" . $sort_column . "&optioncount=1&hierarchical=0";
			if(!empty($se_theme_profile[$name][ 'function' ])){eval($se_theme_profile[$name][ 'function' ]);}
			else{wp_list_cats($wlc);}
			echo $l_after . $after . "\n";
			}

			else if($name == "searchform"){
			echo $before . "\n" . $h_before . $headline . $h_after . "\n";

				if(!$getsearchform){
					?>
					<form method="get" id="searchform" action="<?php bloginfo('url') . $_SERVER['PHP_SELF']; ?>">
					<div><input type="text" value="<?php echo wp_specialchars($s, 1); ?>" name="s" id="s" />
					<input type="submit" id="searchsubmit" value="Search" />
					</div>
					</form>
					<?php
				}	else{include (TEMPLATEPATH . "/searchform.php");}

			echo $after . "\n";

			}

			else if($name == "meta"){
			echo $before . "\n" . $h_before . $headline . $h_after . "\n";
			
			?>
				<ul>
					<?php wp_register(); ?>
					<li><?php wp_loginout(); ?></li>
					<li><a href="http://validator.w3.org/check/referer" title="This page validates as XHTML 1.0 Transitional">Valid <abbr title="eXtensible HyperText Markup Language">XHTML</abbr></a></li>
					<li><a href="http://gmpg.org/xfn/"><abbr title="XHTML Friends Network">XFN</abbr></a></li>
					<li><a href="http://wordpress.org/" title="Powered by WordPress, state-of-the-art semantic personal publishing platform.">WordPress</a></li>
					<?php wp_meta(); ?>
				</ul>
			<?php
			echo $after . "\n";
			}
			else if(file_exists( ABSPATH . "/wp-content/plugins/se_files/add_on/output.php" )){

			include( ABSPATH . "/wp-content/plugins/se_files/add_on/output.php" );

			}

		}
		}
echo $con_after;
if(empty($se_custom_div[ 'after' ])){
	echo "</div>";
}
else{echo $se_custom_div[ 'after' ];}
}

}

if(!function_exists( "value_encode" )){

	function value_encode($t_string){
		$text = str_replace("[-!sq!-]","[\\-!sq!-]",$t_string);
		$text = str_replace("[-!wq!-]","[\\-!wq!-]",$text);
		$text = str_replace("[-!lt!-]","[\\-!lt!-]",$text);
		$t_string = str_replace("[-!gt!-]","[\\-!gt!-]",$text);

//###Check if tags are collectly closed.

		$t_string = str_replace("&gt;","[-!gt!-]",$t_string);
		$t_string = str_replace("&lt;","[-!lt!-]",$t_string);

		if(strstr($t_string,"<")){
			$txt = explode("<",$t_string);
			$i = 0;
			foreach ($txt as $value){
				if($i==0){$entry = str_replace("\"","&quot;",$value);}
				else{
					if(!strstr($value,">") && !$is_script){
					$value = str_replace("\"","&quot;",$value);
					$entry .= "[-!lt!-]" . $value;
					}
					else{
					if(preg_match("/script [^>]{1,}>/",$value)){$is_script=TRUE;}
					else if(stristr($value,"\/script>")){$is_script=FALSE;}
						if($is_script){
							$options = str_replace("\"","[-!wq!-]",$value);
							$options = str_replace("'","[-!sq!-]",$options);
						}
					
					if(!$is_script && strstr($value,"=\"")){
					$t_opt = explode("=\"",$value);
						$ii = 0;
						$options = "";
						foreach($t_opt as $value2){
							if($ii==0){$options = str_replace("\"","&quot;",$value2);}
							else{
								if(!strstr($value2,"\"")){
								$options .= "=&quot;" . $value2;
								}
								else{
								$value3 = str_replace("\"","[-!wq!-]",$value2);
								$options .= "=[-!wq!-]" . $value3;
								}
							}
						$ii++;
						}
					}
					else if(!$is_script){
						$options = str_replace("\"","&quot;",$value);
						}
					$options = str_replace(">","&gt;",$options);
					$entry .= "&lt;" . $options;
					}
				}
				$i++;
			}
		}
		else{$entry = str_replace("\"","&quot;",$t_string);}

		$entry = str_replace(">","[-!gt!-]",$entry);
		$entry = str_replace("'","[-!sq!-]",$entry);

		return $entry;

	}

	}	if(!function_exists( "value_decode" )){


	function value_decode($t_string){
		$text = str_replace("\"","&quot;",$t_string);
		$text = str_replace("[-!sq!-]","'",$text);
		$text = str_replace("[-!wq!-]","\"",$text);
		$text = str_replace("[-!lt!-]","&lt;",$text);
		$text = str_replace("[-!gt!-]","&gt;",$text);
		$text = str_replace("[\\-!sq!-]","[-!sq!-]",$text);
		$text = str_replace("[\\-!wq!-]","[-!wq!-]",$text);
		$text = str_replace("[\\-!lt!-]","[-!lt!-]",$text);
		$text = str_replace("[\\-!gt!-]","[-!gt!-]",$text);
		$text = str_replace("<BR />","\n",$text);
		return $text;
	}

}

if(is_plugin_page()):

	if(file_exists(TEMPLATEPATH . "/se_settings.php")){
	require(TEMPLATEPATH . "/se_settings.php");
	}

	if(file_exists( ABSPATH . "/wp-content/plugins/se_files/add_on/add_on.php" )){
	require( ABSPATH . "/wp-content/plugins/se_files/add_on/add_on.php");
	}

	include_once(ABSPATH . "wp-content/plugins/se_files/gls.php");


//##Default contents of sidebar

	$se_default_content = array(
			array( 
			"visibility" => "+", 
			"name" => "searchform", 
			"content"=>"default", 
			"headline" => "Search", 
			"h_before" => value_encode("<h2>"), 
			"h_after" =>  value_encode("</h2>") 
			),
			array( 
			"visibility" => "+", 
			"name" => "calendar", 
			"content"=>"default" 
			),
			array( 
			"visibility" => "+", 
			"name" => "links", 
			"content"=>"default" 
			),
			array( 
			"visibility" => "+", 
			"name" => "pages", 
			"content"=>"default", 
			"headline" => "Pages", 
			"h_before" =>  value_encode("<h2>"), 
			"h_after" =>  value_encode("</h2>") 
			),
			array( 
			"visibility" => "+", 
			"name" => "archives", 
			"content"=>"default", 
			"headline" => "Archives", 
			"h_before" =>  value_encode("<h2>"), 
			"h_after" =>  value_encode("</h2>"), 
			"l_before" =>  value_encode("<ul>"), 
			"l_after" =>  value_encode("</ul>"), 
			"opt_type" => "monthly", 
			"opt_limit" => 12, 
			"opt_before" => "", 
			"opt_after" => "" 
			),
			array( 
			"visibility" => "+", 
			"name" => "categories", 
			"content"=>"default", 
			"headline" => "Categories", 
			"h_before" =>  value_encode("<h2>"), 
			"h_after" =>  value_encode("</h2>"), 
			"l_before" =>  value_encode("<ul>"), 
			"l_after" =>  value_encode("</ul>"), 
			"sort_column" => "name" 
			),
			array( 
			"visibility" => "+", 
			"name" => "meta", 
			"content"=>"default", 
			"headline" => "Meta", 
			"h_before" =>  value_encode("<h2>"), 
			"h_after" =>  value_encode("</h2>") 
			));

//##Add sections which defined in add-on.

	if(isset($se_default_content_add)){
		foreach($se_default_content_add as $se_def_val){
		$se_default_content[] = $se_def_val;
		}
	}

//##Default options of sidebar

	$se_default_options = array(
			"before"=> value_encode("<li>"),
			"after"=> value_encode("</li>"),
			"con_before"=> value_encode("<ul>"),
			"con_after"=> value_encode("</ul>"),
			"place" => "right"
			);

	$se_action = $_REQUEST['action'];

	switch($se_action){

//###Add custom field###//

	case "se_addNew":

if($_REQUEST[ 'sidebar' ]=="2"){
	$se_new_content = get_option('se_sidebar_contents2');
}	else{
	$se_new_content = get_option('se_sidebar_contents');
}
	$new_org_no = count($se_new_content) - count($se_default_content);
	$se_new_content[] =	array( 
			"visibility" => "+", 
			"name" => "original", 
			"content"=>"Write whatever you want;)", 
			"headline" => "Custom " . $new_org_no, 
			"h_before" => value_encode("<h2>"), 
			"h_after" => value_encode("</h2>"), 
			"l_before" => value_encode("<ul>"), 
			"l_after" => value_encode("</ul>"), 
			"br" => 0
			);

if($_REQUEST[ 'sidebar' ]=="2"){
update_option("se_sidebar_contents2", serialize($se_new_content));
}	else{
update_option("se_sidebar_contents", serialize($se_new_content));
}
echo "<script language='javascript'>location.href='?page=sideeditor.php&sidebar=" . $_REQUEST[ 'sidebar' ] . "';</script>";
die;
break;

//###Update sidebar###//

	case "se_update":

$se_cases_escape = array( 
	"visibility", 
	"name", 
	"headline", 
	"opt_type", 
	"sort_column"
	);

$se_cases_convert = array(
	"h_before", 
	"h_after", 
	"l_before", 
	"l_after", 
	"opt_before", 
	"opt_after",
	"content"
	);
$se_cases_intval = array(
	"opt_limit",
	"br"
	);

//##Add rules for add-on.

if(isset($se_cases_escape_add)){
	foreach($se_cases_escape_add as $se_esc_val){
		$se_cases_escape[] = $se_esc_val;
	}
}
if(isset($se_cases_convert_add)){
	foreach($se_cases_convert_add as $se_conv_val){
		$se_cases_convert[] = $se_conv_val;
	}
}
if(isset($se_cases_intval_add)){
	foreach($se_cases_intval_add as $se_int_val){
		$se_cases_intval[] = $se_int_val;
	}
}

//##Build new construction

$se_states = explode(",",$_POST[ 'state' ]);

	foreach($se_states as $se_val){

		$se_val = ereg_replace("[^0-9]{1,}","",$se_val);

		if($_POST[$se_val][ 'change' ]!="delete"){
		        $respective_res = array();
				foreach($_POST[$se_val] as $key => $se_val2){

				if(in_array($key,$se_cases_escape)){
					$respective_res[ $key ] = wp_specialchars($se_val2,1);
				}
				
				else if(in_array($key,$se_cases_convert)){
					$se_val2 = stripslashes($se_val2);
					$se_val2 = value_encode($se_val2);
					$respective_res[ $key ] = addslashes($se_val2);
				}
				
				else if(in_array($key,$se_cases_intval)){
					if($key == "opt_limit" && $se_val2>30){$se_val2=30;}
					$se_tmp_val = wp_specialchars($se_val2,1);
					$respective_res[ $key ] = intval($se_tmp_val);}
				}
				
			$se_update_content[] = $respective_res;

		}	
	
	}

$top_before = stripslashes($_POST[ 'top' ][ 'before' ]);
$top_before = value_encode($top_before);
$top_before = addslashes($top_before);
$top_after = stripslashes($_POST[ 'top' ][ 'after' ]);
$top_after = value_encode($top_after);
$top_after = addslashes($top_after);

$con_before = stripslashes($_POST[ 'top' ][ 'con_before' ]);
$con_before = value_encode($con_before);
$con_before = addslashes($con_before);
$con_after = stripslashes($_POST[ 'top' ][ 'con_after' ]);
$con_after = value_encode($con_after);
$con_after = addslashes($con_after);
$se_new_place = $_POST[ 'top' ][ 'place' ];

$se_new_options = array(
			"before"=>$top_before,
			"after"=>$top_after,
			"con_before"=>$con_before,
			"con_after"=>$con_after,
			"place"=>$se_new_place
			);

if($_REQUEST[ 'sidebar' ]=="2"){
update_option("se_sidebar_options2", serialize($se_new_options));
update_option("se_sidebar_contents2", serialize($se_update_content));
} else{
update_option("se_sidebar_options", serialize($se_new_options));
update_option("se_sidebar_contents", serialize($se_update_content));
}

echo "<script language='javascript'>location.href='?page=sideeditor.php&sidebar=" . $_POST[ 'sidebar' ] . "';</script>";
die;
break;

//###Initialize or load sidebar###//

	default:

//##Initialize, register values on DB.

if($_REQUEST[ 'refreash' ]=="y"){

	if($_REQUEST[ 'sidebar' ]=="2"){
	update_option("se_sidebar_contents2", serialize($se_default_content), "Sidebar editor plugin");
	update_option("se_sidebar_options2", serialize($se_default_options), "Sidebar editor plugin");
	}	else if($_REQUEST[ 'sidebar' ]=="1"){
	update_option("se_sidebar_contents", serialize($se_default_content), "Sidebar editor plugin");
	update_option("se_sidebar_options", serialize($se_default_options), "Sidebar editor plugin");
	}
echo "<script language='javascript'>location.href='?page=sideeditor.php&sidebar=" . $_REQUEST[ 'sidebar' ] . "';</script>";
die;
}	else{
add_option("se_sidebar_contents", serialize($se_default_content), "Sidebar editor plugin");
add_option("se_sidebar_contents2", serialize($se_default_content), "Sidebar editor plugin");
add_option("se_sidebar_options", serialize($se_default_options), "Sidebar editor plugin");
add_option("se_sidebar_options2", serialize($se_default_options), "Sidebar editor plugin");
}

break;
}

//###Genelate plugin page###//
if($_REQUEST[ 'sidebar' ]=="2"){
$se_saved_content = get_option('se_sidebar_contents2');
$se_saved_option = get_option('se_sidebar_options2');
$se_sidebar_no = 2;
}	else{
$se_saved_content = get_option('se_sidebar_contents');
$se_saved_option = get_option('se_sidebar_options');
$se_sidebar_no = 1;
}
//print_r($se_saved_content);


if(!is_array($se_saved_content)){$se_saved_content = unserialize($se_saved_content);}
if(!is_array($se_saved_option)){$se_saved_option = unserialize($se_saved_option);}
foreach($se_default_content as $se_default_val){

$se_check = 0;
$se_check_ = 0;
	foreach($se_saved_content as $key_ => $se_saved_val){
		if($se_default_val[ 'name' ] == $se_saved_val[ 'name' ]){
			
			foreach($se_default_val as $key => $se_default_val_){
				if(!isset($se_saved_val[ $key ])){ $se_saved_val[ $key ] = $se_default_val_; }
			}
		$se_content[ $key_ ] = $se_saved_val;
		$se_check = 1;
		}
		else if($se_saved_val[ 'name' ] == "original"){
		$se_content[ $key_ ] = $se_saved_val;
		$se_check_ = 1;
		}
		else{
		}
	}
	if($se_check >= 1){$se_check = 0;}
	else{$se_upgrade[] = $se_default_val;}
//echo $se_check;
}
foreach($se_default_options as $key => $se_default_opt_val){
	if(!isset($se_saved_option[ $key ])){$se_option[ $key ] = $se_default_opt_val;}
	else{$se_option[ $key ] = $se_saved_option[ $key ];}
}

//print_r($se_content);

ksort($se_content);

if($se_upgrade){
	foreach($se_upgrade as $se_upgrade_val){
	$se_content[] = $se_upgrade_val;
	}
}


//##Placed left or right

if($se_option[place] == "left"){
$se_p_sel_1=" selected";
$se_p_sel_2="";
$se_p_sel_3="";
}	else if($se_option[place] == "right"){
$se_p_sel_2=" selected";
$se_p_sel_1="";
$se_p_sel_3="";
}	else{
$se_p_sel_3=" selected";
$se_p_sel_1="";
$se_p_sel_2="";
}

if($se_place_changable){$se_is_changable = "true";}

$se_template_path = ABSPATH . "wp-content/plugins/se_files/se_index.html";
$se_rel_path = "../wp-includes/js";

//##Make Values-for-templates set.



$se_plug_res = array( 
		"content" => $se_content,
		"con_before"=>$se_option[con_before],
		"con_after"=>$se_option[con_after],
		"sel1"=>$se_p_sel_1,
		"sel2"=>$se_p_sel_2,
		"sel3"=>$se_p_sel_3,
		"sidebar_no"=>$se_sidebar_no,
		"is_changable"=>$se_is_changable,
		"top_before"=>$se_option[before],
		"top_after"=>$se_option[after],
		"dir" => $se_rel_path,
		"thisscript"=>$_SERVER[ 'REQUEST_URI' ]
		);

//##Paste variables on template file, orderling template by conditional constructions.

$se_pluginlayout = getlayout_str($se_plug_res,$se_template_path);

//##Execute some functions declared on template file, printing plugin page.

template_echo($se_pluginlayout);

endif;

//##Add link on submenu.

if(!function_exists("se_admin_menu")){
function se_admin_menu() {
    $pagefile = basename(__FILE__);
        add_options_page('Sidebar editor', 'Sidebar editor', 8, $pagefile);
	add_submenu_page('themes.php', 'Sidebar editor', 'Sidebar editor', 8, $pagefile);
        }
}

add_action('admin_menu', 'se_admin_menu');


?>
